// album.cpp : Defines the class behaviors for the application.   
// doug overmyer 7/1/93
//

#include "stdafx.h"

#include "albuminc.h"
#include "album.h"     
#include "stsmtr.h"
#include "mainfrm.h"
#include "dibdoc.h"   
#include "dibchild.h"
#include "prntdoc.h"
#include "prntview.h"
#include "dibview.h"         
#include "prntchld.h" 
#include "aboutwnd.h"  
#include <ctl3d.h>  


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
#define new DEBUG_NEW
/////////////////////////////////////////////////////////////////////////////
// CAlbumApp  
/////////////////////////////////////////////////////////////////////////////
// The one and only CAlbumApp object

CAlbumApp NEAR theApp;


BEGIN_MESSAGE_MAP(CAlbumApp, CWinApp)
	//{{AFX_MSG_MAP(CAlbumApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_PRINT_LIST, OnFilePrintList)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)    
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_COMMAND(ID_HELP_INDEX, OnHelpIndex)
	ON_UPDATE_COMMAND_UI(ID_HELP_INDEX, OnUpdateHelpIndex)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

//////////////////////////  CAlbumApp Birth & Death  ///////////////////////
// CAlbumApp construction
// Place all significant initialization in InitInstance

CAlbumApp::CAlbumApp()
{                     

}

// CAlbumApp initialization
BOOL CAlbumApp::InitInstance()
{
	LoadStdProfileSettings();  

  //add a template for display 
	m_pDibTemplate = new CMultiDocTemplate(IDR_DIBTYPE,
			RUNTIME_CLASS(CDibDoc),
			RUNTIME_CLASS(CDibChild),        
			RUNTIME_CLASS(CDibView));
	AddDocTemplate(m_pDibTemplate);  

  //add a template for printing
  m_pPrntTemplate =new CMultiDocTemplate(IDR_PRNTTYPE,
 			RUNTIME_CLASS(CPrntDoc),
 			RUNTIME_CLASS(CPrntChild),        
     	RUNTIME_CLASS(CPrntView));			
  AddDocTemplate(m_pPrntTemplate);
			
	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();
	m_pMainWnd = pMainFrame;    
	//do a splash window
	OnAppAbout();

	// enable file manager drag/drop and DDE Execute open
	m_pMainWnd->DragAcceptFiles();
	EnableShellOpen();
	RegisterShellFileTypes();

	// simple command line parsing
	if (m_lpCmdLine[0] == '\0')
		{
		// create a new (empty) document
		}
	else if ((m_lpCmdLine[0] == '-' || m_lpCmdLine[0] == '/') &&
		(m_lpCmdLine[1] == 'e' || m_lpCmdLine[1] == 'E'))
		{
		// program launched embedded - wait for DDE or OLE open
		}
	else
		{
		// open an existing document
		OpenDocumentFile(m_lpCmdLine);
		}

  Ctl3dRegister(AfxGetInstanceHandle());
  Ctl3dAutoSubclass(AfxGetInstanceHandle());
	return TRUE;
}   

//clean up application
int CAlbumApp::ExitInstance()
{
	SaveStdProfileSettings();    
	Ctl3dUnregister(AfxGetInstanceHandle());
	return CWinApp::ExitInstance();
}

/////////////////////////  On Handlers       ///////////////////////////////
// CAlbumApp commands

// App command to run the dialog
void CAlbumApp::OnAppAbout()
{
	m_pAbout = new CAbout(5,5000,IDB_SPLASH);
}   

// create a doc/view from the clipboard
void CAlbumApp::OnEditPaste()
{
	m_pDibTemplate->OpenDocumentFile("CLIP");	
}

void CAlbumApp::OnFileNew()
{
	// NOP - we only open windows when we have data	
}

//file open
void CAlbumApp::OnFileOpen()
{            
	HGLOBAL	hbuf = ::GlobalAlloc(GHND,4098);
	LPSTR pbuf = (LPSTR)::GlobalLock(hbuf);
	CString path,pathname,file;
	LPSTR pbuf1 = pbuf;                 
	UINT p = 0;
	_fstrcpy(pbuf,"");
	CMainFrame* pMF = (CMainFrame*)m_pMainWnd;	
	CStringList fileList;   
	CStsMtr * pStatusBar = (CStsMtr *)
				LOWORD(m_pMainWnd->SendMessage(UM_GETSTATUSBAR,0,0));                   

	CFileDialog dlg(TRUE);
	dlg.m_ofn.lpstrFile=pbuf; 
	dlg.m_ofn.nMaxFile=4098;
	dlg.m_ofn.lpstrFilter=filter; 
	dlg.m_ofn.Flags +=OFN_ALLOWMULTISELECT;  
	dlg.m_ofn.lpstrTitle="Select Graphics";
	if (dlg.DoModal()==IDOK)
		{  
	  pbuf1=_fstrtok(pbuf," ");
	  path=pbuf1;  
	  pbuf1=_fstrtok(NULL," ");   
	  if (pbuf1 == NULL)
			m_pDibTemplate->OpenDocumentFile(path);
		else
			{	  
			if (path[path.GetLength()-1]=='\\')
				path=path.Left(path.GetLength()-1);
  		while (pbuf1 != NULL)
				{                  
				pathname=path + '\\' + pbuf1;   
				fileList.AddHead(pathname);
				pbuf1=_fstrtok(NULL," ");
				} 
			} 
		}       
	::GlobalUnlock(hbuf);
	::GlobalFree(hbuf);                      
  pStatusBar->SetPct(1); 
  
  UINT uCnt = fileList.GetCount();
  UINT i =0;                     
	POSITION pos=fileList.GetHeadPosition();  
	m_State.bIsNoUpdate = TRUE;
	
	while (pos != NULL)  
		{       
		i++;
		pathname = fileList.GetNext(pos);     
    m_pDibTemplate->OpenDocumentFile(pathname);              
		pStatusBar->SetPct(i * 100 / uCnt);   
		Take5(); 
		}		                        
  pStatusBar->SetPct(0); 
	m_State.bIsNoUpdate = FALSE;
}  
                   
//print a  group of graphics files in album format
//uses prntdoc/prntview combo to run printing operation (view remains hidden)
//files are loaded into memory one at a time to conserve memory
void CAlbumApp::OnFilePrintList()
{                           
	CView* pView;
	CDocument* pDoc;
	POSITION vpos;
	char* pbuf = new char[4098];
	CString path,pathname;
	char* pbuf1 = pbuf;
	strcpy(pbuf,"");	
	CFileDialog dlg(TRUE);
	dlg.m_ofn.lpstrFile=pbuf; 
	dlg.m_ofn.nMaxFile=4098;
	dlg.m_ofn.lpstrFilter=filter;
	dlg.m_ofn.Flags +=OFN_ALLOWMULTISELECT;  
	dlg.m_ofn.lpstrTitle="Select Graphics";
	if ( (dlg.DoModal() != IDOK) || (pbuf == NULL) )
		{	delete []pbuf;return;}

	pDoc=m_pPrntTemplate->OpenDocumentFile(pbuf);
	if (pDoc != NULL)
		vpos=pDoc->GetFirstViewPosition(); 
		if (vpos != NULL)
			{
			pView=pDoc->GetNextView(vpos); 
			pView->SendMessage(WM_COMMAND,ID_FILE_PRINT,0);
			(pView->GetParentFrame())->SendMessage(WM_CLOSE,0,0);
    	}
	delete []pbuf;
}                    

void CAlbumApp::OnFileSave()
{
	// this command not active	
} 

void CAlbumApp::OnHelpIndex()
{
	WinHelp(0,HELP_CONTENTS);
	
}

void CAlbumApp::OnUpdateHelpIndex(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(TRUE);	
}

void CAlbumApp::OnUpdateEditPaste(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(::IsClipboardFormatAvailable(CF_DIB) ||
		::IsClipboardFormatAvailable(CF_METAFILEPICT));
}

//////////////////////////////  Implementation     //////////////////////////////////
// Implementation

//return an updated list of all documents
CObList* CAlbumApp::GetDocList()  
{
	CMultiDocTemplate* pTemplate;
	POSITION dpos,tpos;   
	
	if (! m_docList.IsEmpty())
		m_docList.RemoveAll();   

	tpos=m_templateList.GetHeadPosition();	
	while (tpos != NULL)
		{
		pTemplate = (CMultiDocTemplate*) m_templateList.GetNext(tpos);	
  	dpos =pTemplate->GetFirstDocPosition();	
		while (dpos != NULL)
			m_docList.AddTail(pTemplate->GetNextDoc(dpos));
		}
	return &m_docList;
} 

//return an updated list of all views
CObList* CAlbumApp::GetViewList()
{         
	CDocument* pDoc; 
	CView    * pView = NULL;
	POSITION dpos,vpos;   
	
	if (! m_viewList.IsEmpty())
		m_viewList.RemoveAll();		
	GetDocList();   
	
  dpos = m_docList.GetHeadPosition();	
	while (dpos != NULL)
		{
		pDoc = (CDocument*)m_docList.GetNext(dpos);
		vpos=pDoc->GetFirstViewPosition();
    while (vpos != NULL) 
     	{
     	pView=pDoc->GetNextView(vpos); 
     	// only return CDibViews
     	if ( (pView->IsKindOf(RUNTIME_CLASS(CDibView))) )
        		m_viewList.AddTail(pView);   
       }
		}
	return &m_viewList;
}

// get ini settings, update state info
void CAlbumApp::LoadStdProfileSettings()
{
  CWinApp::LoadStdProfileSettings;
	UINT temp;             
	CString section("Configuration");
	temp = GetProfileInt(section,"LMARGIN",0);
	m_State.m_lMargin = temp / 10.0f;
	temp = GetProfileInt(section,"TMARGIN",0);
	m_State.m_tMargin = temp / 10.0f ;
	temp = GetProfileInt(section,"RMARGIN",0);
	m_State.m_rMargin = temp / 10.0f ;
	temp = GetProfileInt(section,"BMARGIN",0);
	m_State.m_bMargin = temp / 10.0f ;
   
  m_State.m_thumb= GetProfileInt(section,"THUMBNAIL",75);  
  m_State.m_across= GetProfileInt(section,"ACROSS",4); 
  m_State.m_down= GetProfileInt(section,"DOWN",5);
}   

// create a doc/view from a disk file
CDocument* CAlbumApp::OpenDocumentFile( LPCSTR lpszFileName )
{                                                            
	CString fName(lpszFileName);
	return m_pDibTemplate->OpenDocumentFile(fName);
}

//write out ini
void CAlbumApp::SaveStdProfileSettings()
{
	CWinApp::SaveStdProfileSettings;
	UINT temp;             
	CString section("Configuration");
	temp = (UINT)(m_State.m_lMargin * 10);
	WriteProfileInt(section,"LMARGIN",temp);

	temp = (UINT)(m_State.m_rMargin * 10);
	WriteProfileInt(section,"RMARGIN",temp);
	temp = (UINT)(m_State.m_tMargin * 10);
	WriteProfileInt(section,"TMARGIN",temp);
	temp = (UINT)(m_State.m_bMargin * 10);
	WriteProfileInt(section,"BMARGIN",temp);

	WriteProfileInt(section,"THUMBNAIL",m_State.m_thumb);
	WriteProfileInt(section,"ACROSS",m_State.m_across);
	WriteProfileInt(section,"DOWN",m_State.m_down);
}

//update the state structure
void	CAlbumApp::SetStateInfo(SState st)
{
	m_State.m_lMargin= st.m_lMargin; 
	m_State.m_tMargin= st.m_tMargin;
	m_State.m_rMargin= st.m_rMargin;
	m_State.m_bMargin= st.m_bMargin;
	m_State.m_thumb  = st.m_thumb;
	m_State.m_across = st.m_across;
	m_State.m_down   = st.m_down;
}

// peek message loop to breakup lengthy tasks
void CAlbumApp::Take5() 
{                                            
	MSG  msg;
	while ( PeekMessage( &msg,0,0,0,PM_REMOVE)  )
    {
    if (msg.message == WM_QUIT)
    	{
    	PostQuitMessage(msg.wParam);
    	break;
    	}     
    if (! PreTranslateMessage(&msg) )
    	{
    	::TranslateMessage(&msg);  
    	::DispatchMessage(&msg);   
    	}
    }  
//  OnIdle(0);
}

