// dibview.h : interface of the CDibView class
// display bitmap graphics in a view window
// doug overmyer 7/1/93

class CDibView : public CScrollView
{ 
// Attributes
private:
	BOOL m_bIsMoreToPrint;
                                  
protected: // create from serialization only
	CDibView();
	DECLARE_DYNCREATE(CDibView)  
public:  
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	
// Interface
public:
	CDibDoc* GetDocument()
		{
			ASSERT( (m_pDocument->IsKindOf(RUNTIME_CLASS(CDibDoc)))    );
			return (CDibDoc*) m_pDocument;
		}    
	CMainFrame* GetMainFrame()
		{ return (CMainFrame*)AfxGetApp()->m_pMainWnd;}                                                      
  CMDIChildWnd* GetDocFrame()
  	{ return (CMDIChildWnd*) GetParent();}

// On Handlers
public:
	virtual ~CDibView();
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnPrepareDC(CDC* pDC,CPrintInfo* pInfo = NULL);
	virtual void OnInitialUpdate();
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView,
					CView* pDeactiveView);	
// Printing support
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);  
	virtual void OnPrint(CDC* pDC,CPrintInfo* pInfo);  
	virtual void OnPrintThumb(CDC* pDC,CPrintInfo* pInfo, CRect tr);
	virtual void OnPrintCaption(CDC* pDC,CPrintInfo* pInfo, CRect* ptr,CString* pfile); 
	virtual void OnPrintHeader(CDC* pDC,CPrintInfo* pInfo,CString* pfile);
// Generated message map functions
protected:
	//{{AFX_MSG(CDibView)
	afx_msg void OnEditCopy();
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg LRESULT OnDoRealize(WPARAM wParam, LPARAM lParam);  // user message
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

